设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 115|回复: 0

[曲线] 【曲线】圆弧转圆

[复制链接]

已领礼包: 20个

财富等级: 恭喜发财

发表于 2020-7-7 20:11:10 | 显示全部楼层 |阅读模式
  • 插件名称 : 圆弧转圆
  • 作  者 : marting
  • 运行环境 :XDRX API 晓东工具箱 
  • 发布时间 :2020-07-07
  • 命令名称 :xdtb_arc2cir
  • 插件介绍 :【曲线】圆弧转圆
  • 备  注 : (点击图片可以放大)
(点击图片可以放大)

晓东温馨提示 1、运行环境为 晓东工具箱XDRX API 的插件,请下载最新版本的 晓东工具箱XDRX API开发环境 一键安装
2、在ACAD中如何加载插件,请看 论坛插件使用方法
3、如果您有要求需要定制插件,请到 编程申请 论坛发帖求助

插件详细内容

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
  1. (defun c:xdtb_arc2cir (/ ss x i g)
  2.   (xdrx-begin)
  3.   (if (setq ss (xdrx-ssget
  4.                  "\n选择圆弧(支持多段线弧)<退出>:"
  5.                  '((0 . "arc,*polyline"))
  6.                )
  7.       )
  8.     (progn
  9.       (setq i 0)
  10.       (mapcar
  11.         '(lambda (x)
  12.            (if (xdrx-object-iskindof x "arc")
  13.              (progn (setq ss (apply 'xdrx-circle-make
  14.                                     (xdrx-getpropertyvalue
  15.                                       x
  16.                                       "center"
  17.                                       "normal"
  18.                                       "radius"
  19.                                     )
  20.                              )
  21.                     )
  22.                     (xdrx-entity-setpropertiesfrom ss x)
  23.                     (setq i (1+ i))
  24.                     (xdrx-entity-delete x)
  25.              )
  26.              (progn
  27.                (xdrx-polyline-compress x 7)
  28.                (if (and        (= (xdrx-getpropertyvalue x "numverts") 2)
  29.                         (/= 0 (xdrx-getpropertyvalue x "bulgeat" 0))
  30.                    )
  31.                  (progn        (setq g (xdrx-getpropertyvalue x "arcsegat" 0))
  32.                         (setq ss (apply        'xdrx-circle-make
  33.                                         (xdrx-getpropertyvalue
  34.                                           g
  35.                                           "center"
  36.                                           "normal"
  37.                                           "radius"
  38.                                         )
  39.                                  )
  40.                         )
  41.                         (xdrx-entity-setpropertiesfrom ss x)
  42.                         (xdrx-entity-delete x)
  43.                         (setq i (1+ i))
  44.                  )
  45.                )
  46.              )
  47.            )
  48.          )
  49.         (xdrx-pickset->ents ss)
  50.       )
  51.       (xdrx-prompt "\n生成了 " i " 个圆.")
  52.     )
  53.   )
  54.   (xdrx-end)
  55.   (princ)
  56. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2020-11-26 09:37 , Processed in 0.117231 second(s), 23 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表